/*
 * Copyright (c) 2007, Going Dot Com Inc. All rights reserved.
 */

package jp.co.going.xbrl.taxonomy;

import java.sql.Connection;
import java.sql.PreparedStatement;
import java.sql.SQLException;

import jp.co.going.xbrl.common.XbException;

/**
 * @author Going Dot Com Inc.
 */
public class XbTaxonomyGroupDAO {

    // singleton作成
    private static XbTaxonomyGroupDAO taxGrp = null;
    // Connection変数
    private static Connection conn = null;

    // コンストラクタ
    private XbTaxonomyGroupDAO() {
    }

    // インスタンス取得
    public static synchronized XbTaxonomyGroupDAO getInstance(Connection connection) {
        // インスタンスを生成
        if (taxGrp == null) {
            conn = connection;
            taxGrp = new XbTaxonomyGroupDAO();
        }

        return taxGrp;
    }

    protected void insert(XbTaxonomyGroupObj obj)
        throws XbException {

        try {
            // ステートメントを作成
            PreparedStatement stmt;

    		StringBuffer  strb_sql = new StringBuffer();
    	    // 問合せの実行
        	strb_sql.append("insert into ");
        	strb_sql.append("xb_taxonomy_group ");
        	strb_sql.append("values ");
        	strb_sql.append("(?, ?, ?, ?, ?)");

    		// SQL設定
    		stmt = conn.prepareStatement(strb_sql.toString());

    		int index = 1;
    		stmt.setLong(index ++, obj.getTaxonomyGroupId());
    		stmt.setString(index ++, obj.getTaxonomyGroupName());
    		stmt.setString(index ++, obj.getSpecificationNo());
    		stmt.setString(index ++, obj.getNote());
            stmt.setTimestamp(index ++, new java.sql.Timestamp(obj.getCreationDate().getTime()));

            // SQL　実行
    	   	stmt.executeUpdate();

    	    // ステートメントをクローズ
    	    stmt.close();

        } catch (SQLException e) {
            throw new XbException(e, "SQL設定エラー: SQLError : " + e.getMessage());
        }
	}
}